/* BSEARCH.PRG - Binary Search  
	Compile with /n
*/

STATIC lFound := .F.

FUNCTION BFound()
   RETURN lFound

FUNCTION BSearch( xSearchVal, bFldExpr )
   LOCAL nBegin := 1, nEnd := RecCount(), xCurVal
   DO WHILE ( nEnd > nBegin + 1 )
      GOTO nBegin + INT( ( nEnd - nBegin ) / 2 )
      xCurVal := SUBSTR( EVAL( bFldExpr ), 1, LEN( xSearchVal ) )
      DO CASE
      CASE ( xCurVal == xSearchVal )
         lFound := .T.                      // We found it!
         EXIT
      CASE ( xCurVal < xSearchVal )
         nBegin := RECNO()
      CASE ( xCurVal > xSearchVal )
         nEnd := RECNO()
      ENDCASE
   ENDDO
   RETURN ( lFound )

// EOF: Bsearch.prg
